// NOTE: This file will not compile as-is.  You will need to modify it
// to work with your custom permission.  However, the basic structure
// of the test is correct.

// Once you have modified it to work with your custom permission, you
// can compile it via the following commandline:
// "csc /r:testhelper.dll /r:CustomPermission.dll testdriver.cs"
using System;
using System.Security;
using System.Security.Permissions;
using System.Security.Policy;

public class CrossDomainTestDriver {
	private AppDomain MyTestDomain;
    
	public static void Main(String[] args) {
		try {
			CrossDomainTestDriver ADtest = new CrossDomainTestDriver();
			ADtest.RunTest();
		}
		catch (Exception e) {
			Console.WriteLine("Unexpected error occurred");
			Console.WriteLine(e.ToString());
		}
	}

	private void RunTest() {
		MyTestDomain = AppDomain.CreateDomain("test", null,new AppDomainSetup());
		CrossDomainTest TestObj = (CrossDomainTest)MyTestDomain.CreateInstance("TestHelper", "CrossDomainTest").Unwrap();
		CustomPermission cp = new CustomPermission(PermissionState.Unrestricted);
		PermissionSet p1 = new PermissionSet(PermissionState.None);
		p1.AddPermission(cp);
		try {
			p1.Deny();
			TestObj.DemandPermission(p1);
			Console.WriteLine("Fail: A security exception should have been thrown");
		}
		catch(SecurityException se) {
			Console.WriteLine("Pass: A security exception was received appropriately");
			Console.WriteLine(se.ToString());
		}
	}
}