// NOTE: This file will not compile as-is.  It assumes
// Foo.LinkDemandProtectedMethod() has a LinkDemand for some FileIOPermission.
// However, you can modify it to work with any method that has a LinkDemand.

// The expected output on the command line for this scenario is the following:
//   Inside Main
//   Caught exception in Main
//   System.Security.SecurityException: Request for the permission of type
//   System.Security.Permissions.FileIOPermission, mscorlib,
//   Version=1.0.????.0, Culture=neutral, PublicKeyToken=b77a5c561934e089
//   failed.
//   at TestLinkDemand.CallProtectedMethod()
//   at TestLinkDemand.Main()
using System;
using System.Security;
using System.Security.Permissions;

[assembly:FileIOPermission(SecurityAction.RequestRefuse, Unrestricted=true)]
public class TestLinkDemand {
  public static void Main() {
    Console.WriteLine("Inside Main");
    try {
      CallProtectedMethod();
    }
    catch (Exception e) {
      Console.WriteLine("Caught exception in Main");
      Console.WriteLine(e.ToString());
    }
  }

  public static void CallProtectedMethod() {
    Console.WriteLine("Inside CallProtectedMethod");
    Foo f = new Foo();
    f.LinkDemandProtectedMethod();
    Console.WriteLine("Finished calling LinkDemandProtectedMethod");
  }
}
