using System;
using System.IO;
using System.Security;
using System.Security.Permissions;

public class FileIOTest
{
	public static void Main() {
		try {
			if (RunTest()) {
				Console.WriteLine("Pass: File.OpenRead properly protected");
			} else {
				Console.WriteLine("Fail: File.OpenRead not properly protected");
			}
		}
		catch (Exception e) {
			Console.WriteLine("Unexpected error occurred.");
			Console.WriteLine(e.ToString());
		}
	}

	public static bool RunTest() {
		new FileIOPermission(FileIOPermissionAccess.Read, @"C:\test.txt").PermitOnly();
		try {
			FileStream fs = File.OpenRead(@"C:\test.txt");
			return true;
		}
		catch (SecurityException se) {
			return false;
		}
	}
}
