// NOTE: This file will not compile as-is.  It assumes
// Foo.LinkDemandProtectedMethod() has a LinkDemand for some FileIOPermission.
// However, you can modify it to work with any method that has a LinkDemand.

// The expected output on the command line for this scenario is the following:
//   Inside Main
//   Inside CallProtectedMethod
//   Finshed calling LinkDemandProtectedMethod
using System;
using System.Security;
using System.Security.Permissions;

[assembly:FileIOPermission(SecurityAction.RequestMinimum,Read=@"C:\test.txt")]
// The next two assembly permission requests are necessary to execute and get
// a grant set only containing the right to execute and the right to read
// "C:\test.txt".
[assembly:SecurityPermission(SecurityAction.RequestMinimum, Execution=true)]
[assembly:PermissionSet(SecurityAction.RequestOptional, Name="Nothing")]
public class TestLinkDemand {
  public static void Main() {
    Console.WriteLine("Inside Main");
    try {
      CallProtectedMethod();
    }
    catch (Exception e) {
      Console.WriteLine("Caught exception in Main");
      Console.WriteLine(e.ToString());
    }
  }

  public static void CallProtectedMethod() {
    Console.WriteLine("Inside CallProtectedMethod");
    Foo f = new Foo();
    f.LinkDemandProtectedMethod();
    Console.WriteLine("Finshed calling LinkDemandProtectedMethod");
  }
}